#include <AFMotor.h>
#define STOP 0
#define AVANCE 1
#define RECULE 2
#define GAUCHE 3
#define DROITE 4
#define SEUIL_LIGNE 500
#define SEUIL_DIST_1 200
#define SEUIL_DIST_2 500

AF_DCMotor motorD(2, MOTOR12_1KHZ);
AF_DCMotor motorG(1, MOTOR12_1KHZ);
int sensorDroite = A0;
int sensorGauche = A2;
int sensorDistance = A4;
int CapteurD = 0;
int CapteurG = 0;
int CapteurDistance = 0;
bool CG = false;
bool CD = false;
bool Distance1 = false;
bool Distance2 = false;

//*****************************************************************
void setup()
{
  Serial.begin(9600);
  Serial.println("Robot NRV 2018");
}
//*****************************************************************
void loop()
{
  CapteurD = analogRead(sensorDroite);
  CapteurG = analogRead(sensorGauche);
  CapteurDistance = analogRead(sensorDistance);

  if (CapteurG > SEUIL_LIGNE) CG = true;
  else CG = false;
  if (CapteurD > SEUIL_LIGNE) CD = true;
  else CD = false;
  if (CapteurDistance > SEUIL_DIST_1) Distance1 = true;
  else Distance1 = false;
  if (CapteurDistance > SEUIL_DIST_2) Distance2 = true;
  else Distance2 = false;


  if (!Distance1)
  {
    if (!CG && !CD) Mouv(AVANCE, 190);

    if (CG && CD)
    {
      Mouv(STOP, 0);
      delay(200);
    }
    if (CG && !CD)
    {
      Mouv(GAUCHE, 170);
    }
    if (CD && !CG)
    {
      Mouv(DROITE, 170);
    }
  }
  else Mouv(STOP, 0);
  
  if (Distance2) 
  {
    Mouv(RECULE, 255);
    delay(200);
  }
}

//*****************************************************
void Mouv(int Sens, int Vitesse)
{
  switch (Sens)
  {
    case STOP:
      motorD.run(RELEASE);      // stopped
      motorG.run(RELEASE);      // stopped
      break;
    case AVANCE:
      motorD.run(FORWARD);
      motorG.run(FORWARD);
      motorD.setSpeed(Vitesse);
      motorG.setSpeed(Vitesse);
      break;
    case RECULE:
      motorD.run(BACKWARD);     // the other way
      motorG.run(BACKWARD);
      motorD.setSpeed(Vitesse);
      motorG.setSpeed(Vitesse);
      break;
    case DROITE:
      motorD.run(FORWARD);
      motorG.run(FORWARD);
      motorD.setSpeed(0);
      motorG.setSpeed(Vitesse);
      break;
    case GAUCHE:
      motorD.run(FORWARD);
      motorG.run(FORWARD);
      motorG.setSpeed(0);
      motorD.setSpeed(Vitesse);
      break;
  }

}
